# $Id: dnasequenz.py 1316 2015-08-20 07:36:06Z humbert $
# $URL: svn+ssh://l119v.studs.math.uni-wuppertal.de/home/mueller/Kooperation/CDG/repos/Materialsammlung/trunk/oberstufe/skriptum/python_quellen/dnasequenz.py $
#
# Beispiel: Vorhaben Q1-1
# lineare Datenstrukturen -- Liste
#
class Zelle:
  # Die Basen ("A", "C", "G", "T"): base
  # Nächstes Listenelement: naechstes
  def __init__(self):
    self.base= ""
    self.naechstes= None
    
  def printZellenBase(self):
    print(self.base)  
  


class DNASequenz:
  def __init__(self):
    self.start= None   # Objekt der Klasse Zelle


  def fuegeBaseVornEin(self, b: 'str'):
    neueZelleVorn= Zelle()
    
    neueZelleVorn.base= b
    neueZelleVorn.naechstes= self.start

    self.start= neueZelleVorn

  # ...
  def loescheErstes(self):
    self.start= self.start.naechstes

  def length(self):
    zaehler= 0
    cursor= self.start
    while cursor != None:
      zaehler= zaehler + 1
      cursor= cursor.naechstes
    return zaehler


  def printDNA(self): 
    cursor= self.start
    while cursor != None:
      print(cursor.base, end="")  # Python3 - ohne Zeilenumbruch
      cursor= cursor.naechstes
    print()  


  def basen_als_string(self): 
    cursor= self.start
    wert= ""
    while cursor != None:
      wert= wert + cursor.base
      cursor= cursor.naechstes
    return wert


  def komplement(self):
    cursor= self.start
    while cursor != None:
      if   cursor.base == "A": cursor.base = "T"
      elif cursor.base == "T": cursor.base = "A"
      elif cursor.base == "C": cursor.base = "G"
      elif cursor.base == "G": cursor.base = "C"
      cursor= cursor.naechstes


  def suche_erstes_a(self):
    cursor= self.start
    while cursor != None:
      if cursor.base == "A":
        return cursor        # Gefunden! Danke und tschüss.
      cursor= cursor.naechstes
    return None              # Nicht gefunden. Grrr.


  def fuege_ein_nach(self, hier: 'Zelle', b: 'str'):
    fuege_ein          = Zelle()
    fuege_ein.base     = b
    fuege_ein.naechstes= hier.naechstes
    hier.naechstes     = fuege_ein


  def loesche_nach(self, loescheFolgeZelle: 'Zelle'):
    # Löscht die Zelle, die auf loescheFolgeZelle folgt:
    loescheFolgeZelle.naechstes= loescheFolgeZelle.naechstes.naechstes


  def konkateniere_mit(self, mir: 'DNASequenz'):
    pass
    

if __name__ == "__main__":
  sequenz= DNASequenz()

  a= Zelle()
  b= Zelle()
  a.base= "A"
  b.base= "T"

  sequenz= DNASequenz()
  print("erstes A:",sequenz.suche_erstes_a())

  sequenz.fuegeBaseVornEin("A")
  print("erstes A:",end=" ")
  sequenz.suche_erstes_a().printZellenBase()
  sequenz.printDNA()
  
  sequenz.fuegeBaseVornEin("C")
  sequenz.printDNA()
  sequenz.fuegeBaseVornEin("T")
  sequenz.printDNA()

  sequenz.komplement()
  sequenz.printDNA() 
  print(sequenz.basen_als_string())
  
  sequenz.fuege_ein_nach(sequenz.suche_erstes_a(),"C")
  sequenz.printDNA() 
  
  sequenz.loescheErstes()
  sequenz.printDNA()
  sequenz.loescheErstes()
  sequenz.printDNA()

"""\lstinputlisting[linerange={,},language=Python,,style=escapes]{}
# \lstinputlisting[firstline=27,lastline=40]{listings.sty}
# ...
# linerange={ first1 - last1 , first2 - last2 , and so on}
# ...

  # ...
  sequenz.start= a
  a.naechstes  = b
  
  cursor= sequenz.start          # ^\alert<1>{Startsituation}^ 
  tue_was(cursor)
  while cursor.naechstes != None:
    cursor= cursor.naechstes     # ^\alert<2-3>{Vorwärts!}^
    tue_was(cursor)


  cursor= sequenz.start
  while cursor != None:
    tue_was(cursor)
    cursor= cursor.naechstes

  # Algorithmus zum Zählen der Elemente einer Liste
  zaehler= 0
  cursor= sequenz.start
  while cursor != None:
    zaehler= zaehler + 1
    cursor= cursor.naechstes

                                       # ^\alert<1>{1. Ausgangssituation}^
  fuege_ein.naechstes= hier.naechstes  # ^\alert<2>{2. Erste Veränderung}^
  hier.naechstes     = fuege_ein       # ^\alert<3>{3. Fertig}^



    # ...
    
"""

